function [pointlist cube_point_list_and_vertices_of_meshed_object] = set_geometry_object( varargin )
% set object to mesh (object must inherits geometric primitive)        
% input: object to mesh  
% output: point_list and cube_point_list_and_vertices

this=varargin{1};

obj_sampling=this.sampling;
margin=obj_sampling/2;

geometry_to_mesh=varargin{2};


% If mesh size is not set ten get bonding box of the object
if strcmp(this.size_mm,'none')

A=geometry_to_mesh.get_bounding_box();
minx=A(1);
maxx=A(2);
miny=A(3); 
maxy=A(4); 
minz=A(5); 
maxz=A(6);

else
A=this.size_mm;
minx=A(1);
maxx=A(2);
miny=A(3); 
maxy=A(4); 
minz=A(5); 
maxz=A(6);
end

xyz_thick=geometry_to_mesh.get_smallest_thick();

x_object_thick=xyz_thick(1);

y_object_thick=xyz_thick(2);

z_object_thick=xyz_thick(3);

% xthick=abs(maxx-minx);
% 
% ythick=abs(maxy-miny);
% 
% zthick=abs(maxz-minz);

if obj_sampling>x_object_thick
    display('x thick of meshed object is to small, enlarging mesh sampling')
    margin=obj_sampling;
elseif obj_sampling>y_object_thick
    display('y thick of meshed object is to small, enlarging mesh sampling')
    margin=obj_sampling;
elseif obj_sampling>z_object_thick
    display('z thick of meshed object is to small, enlarging mesh sampling')
    margin=obj_sampling;
end


maxxs=maxx+obj_sampling;
maxys=maxy+obj_sampling;
maxzs=maxz+obj_sampling;

minxs=minx-obj_sampling;
minys=miny-obj_sampling;
minzs=minz-obj_sampling;

xthickn=abs(maxxs-minxs);
ythickn=abs(maxys-minys);
zthickn=abs(maxzs-minzs);

 % Coordinates of all the grid points of cube split in smaller cubes
 x_vertices_element_num=ceil(xthickn/obj_sampling);
 x=linspace(minxs,maxxs,x_vertices_element_num);

 y_vertices_element_num=ceil(ythickn/obj_sampling);
 y=linspace(minys,maxys,y_vertices_element_num);

 z_vertices_element_num=ceil(zthickn/obj_sampling);
 z=linspace(minzs,maxzs,z_vertices_element_num);
 
 if strcmp(this.cube_point_list_and_vertices,'none')
 % generate vertex of small cubes
 [X Y Z]=ndgrid(x,y,z);
 
 XYZ = [X(:) Y(:) Z(:)];
 

 %plot3(X(:),Y(:),Z(:),'ro');
 
 % number of small cubes elements
 number_of_small_cubes=1;
 
     for j=1:y_vertices_element_num-1
         for i=1:x_vertices_element_num-1
             for k=1:z_vertices_element_num-1
              % tu s wierzchoki szescianu o wspolrzednych 2 3 4
              %i=1; j=1; k=1;
              % indexowane wsprzednymi
%               i
%               j
%               k
%              [I J K]=ndgrid(i+[0 1],j+[0 1],k+[0 1]);

              [I J K]=ndgrid(i+[0 1],j+[0 1],(z_vertices_element_num)-k+[0 1]);
%               I 
%               J 
%               K
              % indeksem liniowym
              ind=sub2ind(size(X),I,J,K);
       

              % Here coordinates of the small cube
              P=XYZ(ind,:);
              P=P';
              % cube point list describes ech small cube and connected with
              % this cube vestices eg. 1872x3x8 (first value its cube number then 
              % 3 (its dimension: x,y,z) 
              % and 8 (points coordinates of each direction))
              
              cube_point_list_and_vertices(number_of_small_cubes,:,:,:)=P(:,:,:);
              number_of_small_cubes=number_of_small_cubes+1;
              
              P=[];
             end
         end
     end
 else
     cube_point_list_and_vertices=this.cube_point_list_and_vertices;
 end
% status=cube_point_list_and_vertices;
%  figure
%  for p=1:max(size(cube_point_list_and_vertices(:,1,1)))
%      hold on;
% 
%      xyz_plot(:,:)=cube_point_list_and_vertices(p,:,:);
%      x=xyz_plot(1,:);
%      y=xyz_plot(2,:);
%      z=xyz_plot(3,:);
%      plot3(x,y,z,'ro');
%      hold off;
%  end

check_point_matrix=zeros(size(cube_point_list_and_vertices));

for u=1:max(size(cube_point_list_and_vertices(:,1,1)))
     xyz_cube(:,:)=cube_point_list_and_vertices(u,:,:);
     x=xyz_cube(1,:);
     y=xyz_cube(2,:);
     z=xyz_cube(3,:);
     for i=1:length(x)
                           
         sts=geometry_to_mesh.check_if_point_belongs_to_object([x(i) y(i) z(i)],[margin margin 1]);
      
         if(sts==1)        
%             hold on;
%             plot3(x(i),y(i),z(i),'bo');
            check_point_matrix(u,:,i)=1;
         end
     end
end


pl=1;
for i=1:max(size(cube_point_list_and_vertices(:,1,1)))
    point=check_point_matrix(i,:,:);
    
    summ=sum(sum(point));
    
    if (summ>=15)
        pointlist(pl)=i;
        pl=pl+1;
    end    
end

%[K,L,M] = IND2SUB(size(X),pointlist);

%plot3(K,L,M,'ro');

discrete_element_x=x_vertices_element_num-1;
discrete_element_y=y_vertices_element_num-1;
discrete_element_z=z_vertices_element_num-1;

this.size_discrete_xyz=[discrete_element_x discrete_element_y discrete_element_z];
    
this.cube_point_list_and_vertices=cube_point_list_and_vertices;

cube_point_list_and_vertices_of_meshed_object=cube_point_list_and_vertices(pointlist,:,:);



%  for p=1:max(size(pointlist))
%      hold on;
%      xyz_plot(:,:)=cube_point_list_and_vertices(pointlist(p),:,:);
%       x=xyz_plot(1,:);
%       y=xyz_plot(2,:);
%       z=xyz_plot(3,:);
% %      plot3(x,y,z,'ro');
%      
%      left_down_corner=[x(1) y(1) z(1)];
%      
%      dxyz=[abs(x(1)-x(8)) abs(y(1)-y(8)) abs(z(1)-z(8))];
%      
%      voxel( left_down_corner, dxyz, [1 0 0], [1 1 1], 0.3  );
%      
%      hold off;
%      %status(p,:,:)=cube_point_list_and_vertices(pointlist(p),:,:);
%  end


max_num=discrete_element_z*discrete_element_y*discrete_element_x;

%[I1,I2,I3] = ind2sub([1,1,1],1)

%  for p=1:max_num
%      hold on;
%      xyz_plot(:,:)=cube_point_list_and_vertices(p,:,:);
%       x=xyz_plot(1,:);
%       y=xyz_plot(2,:);
%       z=xyz_plot(3,:);
% %      plot3(x,y,z,'ro');
%      
%      left_down_corner=[x(1) y(1) z(1)];
%      
%      dxyz=[abs(x(1)-x(8)) abs(y(1)-y(8)) abs(z(1)-z(8))];
%      
%      voxel( left_down_corner, dxyz, [1 0 0], [1 1 1], 0.3  );
%      pause
%      hold off;
%      %status(p,:,:)=cube_point_list_and_vertices(pointlist(p),:,:);
%  end


size(pointlist);

[I J K]=ind2sub([x_vertices_element_num-1,y_vertices_element_num-1,z_vertices_element_num-1],pointlist);

%pcolor(X,Y,Z(i)); shading flat
 M=zeros(x_vertices_element_num-1,y_vertices_element_num-1,z_vertices_element_num-1);
% M(I,J,K)=1;
% 
% plot3(I,J,K,'hr')

%imagesc(M);
%pcolor(I,J,K(2));shading flat

%   i=2; j=3; k=4;
%  % indexowane wsprzednymi
%  [I J K]=ndgrid(i+[0 1],j+[0 1],k+[0 1]);
%  % indeksem liniowym
%  ind=sub2ind(size(X),I,J,K);
 
 %XYZ=XYZ';
 %plot3(XYZ(1,:),XYZ(2,:),XYZ(3,:),'ro');

 % index small cubes
%  x_v=linspace(1,x_vertices_element_num,x_vertices_element_num);
%  y_v=linspace(1,y_vertices_element_num,y_vertices_element_num);
%  z_v=linspace(1,z_vertices_element_num,z_vertices_element_num);
%  [Xn Yn Zn]=ndgrid(x_v, y_v, z_v);
%  Xn 
%  Yn 
%  Zn
%  % cube indexed at (2,3,4)
%  i=2; j=3; k=4;
%  [I J K]=ndgrid(i+[0 1],j+[0 1],k+[0 1]);
%  ind=sub2ind(size(X),I,J,K)
% 
%  % Here coordinates of the small cube
%  XYZ(ind,:)

%status=1;

end