function [neighbour_point_list_vector xyz_matrix_indicies] = get_neighbours(varargin)
% point_list_value point list value of discret element
% returns neighbour_point_list_vector vector of point list values (6 elements)
% and xyz_matrix indicies of neighbours (6x3)
%#eml

this=varargin{1};

pointlist=varargin{2};

size_discrete_xyz=this.size_discrete_xyz;

[x y z]=ind2sub(size_discrete_xyz,pointlist);

x_max=this.size_discrete_xyz(1);
y_max=this.size_discrete_xyz(2);
z_max=this.size_discrete_xyz(3);

neighbour_point_list_vector=zeros(6,1);
xyz_matrix_indicies=zeros(6,3);

% UP
x_val=x;
y_val=y;
z_val=z+1;

if 0<x_val && x_val<x_max && 0<y_val && y_val<y_max && 0<z_val && z_val<z_max
    
    xyz_matrix_indicies(1,:)=[x_val, y_val, z_val];
    linearInd = sub2ind(size_discrete_xyz, x_val, y_val,z_val);
    neighbour_point_list_vector(1)=linearInd;
else 
    neighbour_point_list_vector(1)=pointlist;
end

% Down
x_val=x;
y_val=y;
z_val=z-1;

if 0<x_val && x_val<x_max && 0<y_val && y_val<y_max && 0<z_val && z_val<z_max
    
    xyz_matrix_indicies(2,:)=[x_val, y_val, z_val];
    linearInd = sub2ind(size_discrete_xyz, x_val, y_val,z_val);
    neighbour_point_list_vector(2)=linearInd;
else 
    neighbour_point_list_vector(2)=pointlist;
end

% left
x_val=x-1;
y_val=y;
z_val=z;

if 0<x_val && x_val<x_max && 0<y_val && y_val<y_max && 0<z_val && z_val<z_max
    
    xyz_matrix_indicies(3,:)=[x_val, y_val, z_val];
    linearInd = sub2ind(size_discrete_xyz, x_val, y_val,z_val);
    neighbour_point_list_vector(3)=linearInd;
else 
    neighbour_point_list_vector(3)=pointlist;
end

% right
x_val=x+1;
y_val=y;
z_val=z;

if 0<x_val && x_val<x_max && 0<y_val && y_val<y_max && 0<z_val && z_val<z_max
    
    xyz_matrix_indicies(4,:)=[x_val, y_val, z_val];
    linearInd = sub2ind(size_discrete_xyz, x_val, y_val,z_val);
    neighbour_point_list_vector(4)=linearInd;
else 
    neighbour_point_list_vector(4)=pointlist;
end

% back
x_val=x;
y_val=y-1;
z_val=z;

if 0<x_val && x_val<x_max && 0<y_val && y_val<y_max && 0<z_val && z_val<z_max
    
    xyz_matrix_indicies(5,:)=[x_val, y_val, z_val];
    linearInd = sub2ind(size_discrete_xyz, x_val, y_val,z_val);
    neighbour_point_list_vector(5)=linearInd;
else 
    neighbour_point_list_vector(5)=pointlist;
end

% front
x_val=x;
y_val=y+1;
z_val=z;

if 0<x_val && x_val<x_max && 0<y_val && y_val<y_max && 0<z_val && z_val<z_max
    
    xyz_matrix_indicies(6,:)=[x_val, y_val, z_val];
    linearInd = sub2ind(size_discrete_xyz, x_val, y_val,z_val);
    neighbour_point_list_vector(6)=linearInd;
else 
    neighbour_point_list_vector(6)=pointlist;
end

end

