function [pointlist cube_point_list_and_vertices_of_meshed_object] = set_geometry_object( varargin )
% set object to mesh (object must inherits geometric primitive)        
% input: object to mesh  
% output: point_list and cube_point_list_and_vertices

this=varargin{1};

obj_sampling=this.sampling;
margin_bunding_box=obj_sampling;
margin=[0 0 0];

geometry_to_mesh=varargin{2};


% If mesh size is not set ten get bonding box of the object
if strcmp(this.size_mm,'none')

A=geometry_to_mesh.get_bounding_box();
minx=A(1);
maxx=A(2);
miny=A(3); 
maxy=A(4); 
minz=A(5); 
maxz=A(6);

else
A=this.size_mm;
minx=A(1);
maxx=A(2);
miny=A(3); 
maxy=A(4); 
minz=A(5); 
maxz=A(6);
end

xyz_thick=geometry_to_mesh.get_smallest_thick();

x_object_thick=xyz_thick(1);

y_object_thick=xyz_thick(2);

z_object_thick=xyz_thick(3);


xthick=abs(maxx-minx);

ythick=abs(maxy-miny);

zthick=abs(maxz-minz);

% min_thick=min(xyz_thick);
% 
% if obj_sampling>min_thick    
%     margin=obj_sampling/2+obj_sampling*0.1;
%     display('size of meshed object is to small, enlarging mesh sampling')
% end


if obj_sampling(1)>x_object_thick
    display('x thick of meshed object is to small, enlarging mesh sampling')
    margin(1)=obj_sampling(1)/2+obj_sampling(1)*0.1;
elseif obj_sampling(2)>y_object_thick
    display('y thick of meshed object is to small, enlarging mesh sampling')
    margin(2)=obj_sampling(2)/2+obj_sampling(2)*0.1;
elseif obj_sampling(3)>z_object_thick
    display('z thick of meshed object is to small, enlarging mesh sampling')
    margin(3)=obj_sampling(3)/2+obj_sampling(3)*0.1;
end



% calculate grid only ones
if strcmp(this.X_disp,'none')

maxxs=maxx+obj_sampling(1);
maxys=maxy+obj_sampling(2);
maxzs=maxz+obj_sampling(3);

minxs=minx-obj_sampling(1);
minys=miny-obj_sampling(2);
minzs=minz-obj_sampling(3);

xthickn=abs(maxxs-minxs);
ythickn=abs(maxys-minys);
zthickn=abs(maxzs-minzs);

 % Coordinates of all the grid points of cube split in smaller cubes
 x_vertices_element_num=ceil(xthickn/obj_sampling(1));
 
 x=linspace(minxs,maxxs,x_vertices_element_num);
 this.x_mm_cube_corners=x;
 
 x_mm_centers=x+obj_sampling(1)/2;
 this.x_mm_centers=x_mm_centers(1:(length(x_mm_centers)-1));
 
 %%%
 y_vertices_element_num=ceil(ythickn/obj_sampling(2));
 
 y=linspace(minys,maxys,y_vertices_element_num);
 this.y_mm_cube_corners=y;
 
 y_mm_centers=y+obj_sampling(2)/2;
 this.y_mm_centers=y_mm_centers(1:(length(y_mm_centers)-1));
 
 %%%
 z_vertices_element_num=ceil(zthickn/obj_sampling(3));
 
 z=linspace(minzs,maxzs,z_vertices_element_num);
 this.z_mm_cube_corners=z;
 
 z_mm_centers=z+obj_sampling(3)/2;
 this.z_mm_centers=z_mm_centers(1:(length(z_mm_centers)-1));
 
 [X_disp Y_disp Z_disp]=meshgrid(this.x_mm_centers,this.y_mm_centers,this.z_mm_centers);
 
 this.X_disp=X_disp;
 this.Y_disp=Y_disp;
 this.Z_disp=Z_disp;
 
    discrete_element_x=x_vertices_element_num-1;
    discrete_element_y=y_vertices_element_num-1;
    discrete_element_z=z_vertices_element_num-1;
 
     this.size_discrete_xyz=[discrete_element_x discrete_element_y discrete_element_z];
end

%  X_disp=this.X_disp;
%  Y_disp=this.Y_disp;
%  Z_disp=this.Z_disp;
%  
%  XX=reshape(X_disp,1,numel(X_disp));
%  YY=reshape(Y_disp,1,numel(Y_disp));
%  ZZ=reshape(Z_disp,1,numel(Z_disp));
%  
% 
%  onesy=ones(1,numel(XX));
%  margin=margin.*onesy;
%  
%  sts=geometry_to_mesh.check_if_point_belongs_to_object(XX, YY, ZZ, margin, margin, margin);
%  
% %  for i=1:numel(X_disp)
% %  sts(i)=geometry_to_mesh.check_if_point_belongs_to_object(X_disp(i) ,Y_disp(i) ,Z_disp(i),margin(i) ,margin(i), onesy(i));
% %  end
%  
% %logical indexing
% 
% pointlist=find(sts==1);
%  
% %  pl_ind=1;
% %  for i=1:numel(sts)     
% %      if sts(i)==1
% %          pointlist(pl_ind)=i;
% %          pl_ind=pl_ind+1;
% %      end    
% %  end
%  
%  
%  cube_point_list_and_vertices_of_meshed_object=1;
 
% bounding box volumes copy

 X_disp=this.X_disp;
 Y_disp=this.Y_disp;
 Z_disp=this.Z_disp;

 
 A=geometry_to_mesh.get_bounding_box();
% A=A+margin_bunding_box;
minxo=A(1)-margin_bunding_box(1);
maxxo=A(2)+margin_bunding_box(1);

minyo=A(3)-margin_bunding_box(2);
maxyo=A(4)+margin_bunding_box(2);

minzo=A(5)-margin_bunding_box(3);
maxzo=A(6)+margin_bunding_box(3);

 
 XX=reshape(X_disp,1,numel(X_disp));
 YY=reshape(Y_disp,1,numel(Y_disp));
 ZZ=reshape(Z_disp,1,numel(Z_disp));
 
% iidx to XX YY ZZ point list
 %point_list_of_volume=find(minxo<XX<maxxo | minyo<YY<maxyo | minzo<ZZ<maxzo);  
 fx1=find(XX<=maxxo);
fx2=find(XX>=minxo);

samex=intersect(fx1,fx2);

fy1=find(YY<=maxyo);
fy2=find(YY>=minyo);

samey=intersect(fy1,fy2);


fz1=find(ZZ<=maxzo);
fz2=find(ZZ>=minzo);

samez=intersect(fz1,fz2);

samexy=intersect(samex,samey);
point_list_of_volume=intersect(samexy,samez);
 
 onesy=ones(1,numel(point_list_of_volume));
 margin_x=margin(1).*onesy;
 margin_y=margin(2).*onesy;
 margin_z=margin(3).*onesy;
 
 sts=geometry_to_mesh.check_if_point_belongs_to_object(XX(point_list_of_volume), YY(point_list_of_volume), ZZ(point_list_of_volume), margin_x, margin_y, margin_z);
 
%  for i=1:numel(X_disp)
%  sts(i)=geometry_to_mesh.check_if_point_belongs_to_object(X_disp(i) ,Y_disp(i) ,Z_disp(i),margin(i) ,margin(i), onesy(i));
%  end
 
%logical indexing

correct_points_from_volume = sts==1;

pointlist=point_list_of_volume(correct_points_from_volume);
 
%  pl_ind=1;
%  for i=1:numel(sts)     
%      if sts(i)==1
%          pointlist(pl_ind)=i;
%          pl_ind=pl_ind+1;
%      end    
%  end
 
 
 cube_point_list_and_vertices_of_meshed_object=1;

end
