function  [stts]= check_if_point_belongs_to_object_cuboid( varargin )
% chech if given point (x,y,z) is a part of object. Margin is
% for computation accuracy (rounding object to mesh) usualy half of grid step in each coordinate.
% varargin{1} - object
% varargin{2} - vector with x y z coordinates
% varargin{3} - vector with z r alfa margins 
% output_args = 1 (true) if point belongs to object otherwise 0 (false)


this=varargin{1};
vector_xyz=varargin{2};
margin_xyz=varargin{3};

x=vector_xyz(1);
y=vector_xyz(2);
z=vector_xyz(3);

zm=margin_xyz(1);
rm=margin_xyz(2);
am=margin_xyz(3);

A=this.get_bounding_box();

minx=A(1);
maxx=A(2);
miny=A(3); 
maxy=A(4); 
minz=A(5); 
maxz=A(6);

minx=minx-zm;
maxx=maxx+zm;
miny=miny-zm; 
maxy=maxy+zm; 
minz=minz-zm; 
maxz=maxz+zm;
          
if x >= minx && x <=maxx;
    if y >= miny && y <=maxy;        
        if z >= minz && z <=maxz;        
            stts=1;
        else
            stts=0;
        end
    else
        stts=0;
    end
else 
    stts=0;
end

end

