function  [sts_mtrx]= check_if_point_belongs_to_object( varargin )
% check if given point (x,y,z) is a part of object. Margin is
% for computation accuracy (rounding object to mesh) usualy half of grid step in each coordinate.
% varargin{1} - object
% varargin{2} - vector with x y z coordinates
% varargin{3} - vector with z r alfa margins 
% output_args = 1 (true) if point belongs to object otherwise 0 (false)

   %             geometry.rmin= rmin_mm [milimeters] radius-inner part of element
   %             geometry.rmax= rmax_mm [milimeters] radius-outer part of element
   % 
   %             geometry.start_angle_deg= start_angle [degree] where object begins
   %             geometry.stop_angle_deg= stop_angle [degree] where object ends
   % 
   %             geometry.h_high= upper height of the element (z-axis)
   %             geometry.h_low
   
 this=varargin{1};
% vector_xyz=varargin{2};
% margin_zra=varargin{3};
xsq=varargin{2}; 
ysq=varargin{3}; 
zsq=varargin{4};
margin=varargin{5};
onesy=varargin{6};

 geom=this.geometry;
%    object_size=[geom.rmax,...
%                 geom.rmin,...
%                 geom.x_centre,...
%                 geom.y_centre,...
%                 geom.h_high,...
%                 geom.h_low,...
%                 geom.start_angle_deg,...
%                 geom.stop_angle_deg];
            
onesz=ones(size(xsq));
grx=onesz*geom.rmax;
grn=onesz*geom.rmin;
gxc=onesz*geom.x_centre;
gyc=onesz*geom.y_centre;
ghh=onesz*geom.h_high;
ghl=onesz*geom.h_low;
gsta=onesz*geom.start_angle_deg;
gsto=onesz*geom.stop_angle_deg;
            
sts_mtrx = arrayfun(@(x,y,z,m,n,p,q,w,e,r,t,h,u,i) check_if_point_belongs_to_object_cylinder([x y z],[m n p],[q,w,e,r,t,h,u,i] ), xsq, ysq, zsq,margin, margin, onesy,grx,grn,gxc,gyc,ghh,ghl,gsta,gsto);
      
  % stts=check_if_point_belongs_to_object_cylinder(varargin{2},varargin{3},object_size);
   
   
% this=varargin{1};
% vector_xyz=varargin{2};
% margin_zra=varargin{3};
% 
% x=vector_xyz(1);
% y=vector_xyz(2);
% z=vector_xyz(3);
% 
% zm=margin_zra(1);
% rm=margin_zra(2);
% am=margin_zra(3);
% 
% 
% obj_r_high = this.geometry.rmax;
% obj_r_low  = this.geometry.rmin;
% 
% obj_r_highm = obj_r_high + rm;
% obj_r_lowm  = obj_r_low - rm;
% 
% xc=this.geometry.x_centre;
% yc=this.geometry.y_centre;
% 
% R = hypot(x-xc,y-yc);
% 
% % outside side
% if (R<= obj_r_highm && R >= obj_r_lowm)
%     
%     obj_z_high = this.geometry.h_high;
%     obj_z_low  = this.geometry.h_low;
% 
%     obj_z_highm=obj_z_high+zm;
%     obj_z_lowm=obj_z_low-zm;
%     
%     if obj_z_lowm<=z && z<=obj_z_highm
%                 
% %             x_old=x;
% %             y_old=y;
% %             
% %             if x>=0 || y>=0
% %                 x=x-xc;
% %                 y=y-yc;
% %                         
% %             elseif x<=0 || y>=0
% %                 x=x+xc;
% %                 y=y-yc;            
% %                 
% %             elseif x<=0 || y<=0
% %                 x=x+xc;
% %                 y=y+yc;            
% %             
% %             elseif x>=0 || y<=0
% %                 x=x-xc;
% %                 y=y+yc;
% %             end
% %             
% %             [TH,R]=cart2pol(x,y);
%             % cart2pol returns:
%             TH = atan2(y-yc,x-xc);
%             % THETA is a counterclockwise angular displacement in radians from the positive x-axis
%             % this is not exactly what we want    TH <-pi;pi>
% 
%             TH = TH * (180/pi); % transform to degrees
% 
%             TH = mod(TH,360); % keep it 0<=TH<360
% 
%             if TH<0
%                 TH=TH+360;                
%             end
%             
%             obj_a_start = this.geometry.start_angle_deg;
%             obj_a_stop  = this.geometry.stop_angle_deg;
%         
%             obj_a_startm = obj_a_start -am;
%             obj_a_stopm  = obj_a_stop +am;
%          
%             if obj_a_startm<0
%                 if TH>=360+obj_a_startm                    
%                     TH=TH-360;                    
%                 end
%             end
%             
%         if TH >= obj_a_startm && TH <=obj_a_stopm;
% 
%            stts=1;
% %            hold on;
% %            plot3(x_old,y_old,z,'ro');
%            
%         else 
%             stts=0;
%         end
%         
%     else
%         stts=0;
%     end              
%        
% else 
%     stts=0;
% end



