classdef eCylinder < eGeometric_Primitive
    %CYLINDRICAL_Object descirbes cylindrical element
    % constructor 
        % geometry.rmin=;
        % geometry.rmax=
        % 
        % geometry.start_angle_deg=
        % geometry.stop_angle_deg=
        % 
        % geometry.h_high=
        % geometry.h_low=
        % 
        % geometry.x_centre=; % center of a cylinder
        % geometry.y_centre=;
        % geometry.accuracy=;
    
    properties (SetAccess='protected')
        %sketch_data % points which descibes only border points od element
        %geometry
        % geometry.rmin=
        % geometry.rmax=
        % 
        % geometry.start_angle_deg=
        % geometry.stop_angle_deg=
        % 
        % geometry.h_high=
        % geometry.h_low=
        % 
        % geometry.x_centre=; % center of a cylinder
        % geometry.y_centre=;
        % geometry.accuracy=;
    end
    
    methods (Access='public')
        function CE_obj = eCylinder(varargin)
          if nargin > 0 ; % no input arguments
          if isa(varargin{1},'eCylinder')
            CE_obj = varargin{1}; % copy constructor
            display 'Copy constructor eCylinder'
            return;                     
          else
               switch(nargin)
                   
                case 1,
                    
                if(strcmp(varargin{1},'wizard'))
                    
                    CE_obj.wizard(); %set geometry from input

                else
                    
                    CE_obj.geometry=varargin{1};
                    
                end                  

                    n = CE_obj.geometry.accuracy;
                    rmin=CE_obj.geometry.rmin;
                    rmax=CE_obj.geometry.rmax;

                    start_angle_deg=CE_obj.geometry.start_angle_deg;
                    if (start_angle_deg>360)
                        start_angle_deg=mod(start_angle_deg,360);
                    end
                    
                    CE_obj.geometry.start_angle_deg=start_angle_deg;
                    
                    stop_angle_deg=CE_obj.geometry.stop_angle_deg;
                    if (stop_angle_deg>360)
                        stop_angle_deg=mod(stop_angle_deg,360);
                    end
                    
                    CE_obj.geometry.stop_angle_deg=stop_angle_deg;
                    
                    if(start_angle_deg>stop_angle_deg)
                        CE_obj.geometry.start_angle_deg=-(360-start_angle_deg);   
                        start_angle_deg=CE_obj.geometry.start_angle_deg;
                    end

                    h_high=CE_obj.geometry.h_high;
                    h_low=CE_obj.geometry.h_low;

                    x0=CE_obj.geometry.x_centre; % center of a cylinder
                    y0=CE_obj.geometry.y_centre;               


                    % ****compute****

                    % degrees to radian
                    %Rad = ( PI * degree / 180 )
                    start_angle_rad=( pi * start_angle_deg / 180 );
                    stop_angle_rad=( pi * stop_angle_deg / 180 );

                    r = [rmax rmin]';   
                    r_scianaprzednia=[rmin rmin]';
                    r_scianatylnia=[rmax rmax]';

                    m = length(r); 

                    theta=linspace(start_angle_rad,stop_angle_rad,n);
                    sintheta = sin(theta); %sintheta(n+1) = sintheta(n);

                    % cylindrical coordinate system
                    CE_obj.sketch_data.x1 = x0+r * cos(theta);  
                    CE_obj.sketch_data.y1 = y0+r * sintheta;
                    CE_obj.sketch_data.z1 = (0:m-1)'/(m-1) * ones(1,n)* h_low;
                    CE_obj.sketch_data.z1 = ones(size(CE_obj.sketch_data.z1)).*h_low;

                    CE_obj.sketch_data.x2 = x0+r * cos(theta);  
                    CE_obj.sketch_data.y2 = y0+r * sintheta;
                    CE_obj.sketch_data.z2 = ones(size(CE_obj.sketch_data.z1)).*h_high;

                    % cylindrical coordinate system
                    % front wall of a cylinder
                    CE_obj.sketch_data.x3 = x0+r_scianaprzednia * cos(theta);  
                    CE_obj.sketch_data.y3 = y0+r_scianaprzednia * sintheta;  
                    CE_obj.sketch_data.z3 = (0:m-1)'/(m-1) * ones(1,n);  
                    CE_obj.sketch_data.z3(1,1:length(CE_obj.sketch_data.z3))=h_high;
                    CE_obj.sketch_data.z3(2,1:length(CE_obj.sketch_data.z3))=h_low;

                    % cylindrical coordinate system
                    % back wall of a cylinder
                    CE_obj.sketch_data.x4 = x0+r_scianatylnia * cos(theta);  
                    CE_obj.sketch_data.y4 = y0+r_scianatylnia * sintheta;
                    CE_obj.sketch_data.z4 = (0:m-1)'/(m-1) * ones(1,n);
                    CE_obj.sketch_data.z4(1,1:length(CE_obj.sketch_data.z4))=h_high;
                    CE_obj.sketch_data.z4(2,1:length(CE_obj.sketch_data.z4))=h_low;

                    % start wall

                    if((rmin==0 && rmax==360)||(rmin==360 && rmax==0))
                        [start_minx start_miny]=pol2cart(start_angle_rad,rmin);
                        [start_maxx start_maxy]=pol2cart(start_angle_rad,rmax);

                        xst=[start_minx,start_maxx;start_minx,start_maxx];
                        yst=[start_miny,start_maxy;start_miny,start_maxy];
                        zst=[h_low,h_low;h_high,h_high];


                        CE_obj.sketch_data.xst=xst;
                        CE_obj.sketch_data.yst=yst;
                        CE_obj.sketch_data.zst=zst;     
                    else
                        CE_obj.sketch_data.xst=[0,0;0,0];
                        CE_obj.sketch_data.yst=[0,0;0,0];
                        CE_obj.sketch_data.zst=[0,0;0,0];     
                    end  


                    % stop wall
                    if((rmin==0 && rmax==360)||(rmin==360 && rmax==0))
                        [stop_minx stop_miny]=pol2cart(stop_angle_rad,rmin);
                        [stop_maxx stop_maxy]=pol2cart(stop_angle_rad,rmax);

                        xsp=[stop_minx,stop_maxx;stop_minx,stop_maxx];
                        ysp=[stop_miny,stop_maxy;stop_miny,stop_maxy];
                        zsp=[h_low,h_low;h_high,h_high];

                        CE_obj.sketch_data.xsp=xsp;
                        CE_obj.sketch_data.ysp=ysp;
                        CE_obj.sketch_data.zsp=zsp;   
                    else
                        CE_obj.sketch_data.xsp=[0,0;0,0];
                        CE_obj.sketch_data.ysp=[0,0;0,0];
                        CE_obj.sketch_data.zsp=[0,0;0,0];   
                    end
                
                
               otherwise,
                         error('Too less or too much input elements');
               end % switch
               
          end
          end
        
        end % constructor
    
        % display sketch of the object, set color of the object
        % e.g. 
        % color.r=0; 
        % color.g=0.5;
        % color.b=0.6; 
        % return plots handle
        [h_plot]=sketch(varargin);        
        
        % chech if given point (x,y,z) is a part of object. Margin is
        % for computation accuracy (rounding object to mesh) usualy half of grid step in each coordinate.
        [stts]= check_if_point_belongs_to_object( varargin )
        
        % return bounding values xmin, xmax etc
        % [xmin xmax ; ymin ymax ; zmin zmax ]
        [bounding_box_xyz]=get_bounding_box(varargin)        
        
        %return smallest object thick in each dimension (x, y, z)
        [xyz_thick]=get_smallest_thick(varargin)
        
    end % methods
    
    methods (Access='private')
        
        function wizard(ec_obj)
            display 'Cylinder parameters.'
            
            in=input('Maximal radius[mm]: ', 's');

            if isempty(in)
                error('empty value')
            end
            
            ec_obj.geometry.rmax=str2double(in);
            
            % next val
            
            in=input('Minimal radius[mm]: ', 's');

            if isempty(in)
                error('empty value')
            end
            
            ec_obj.geometry.rmin=str2double(in);
            
            % next val
            
            in=input('Start angle[degree]: ', 's');

            if isempty(in)
                error('empty value')
            end
            
            ec_obj.geometry.start_angle_deg=str2double(in);
            
            % next val
            
            in=input('Stop angle[degree]: ', 's');

            if isempty(in)
                error('empty value')
            end
            
            ec_obj.geometry.stop_angle_deg=str2double(in);
            
            % next val

            in=input('Max high[mm]: ', 's');

            if isempty(in)
                error('empty value')
            end
            
            ec_obj.geometry.h_high=str2double(in);
            
            % next val
            
            in=input('Min high[mm]: ', 's');

            if isempty(in)
                error('empty value')
            end
            
            ec_obj.geometry.h_low=str2double(in);
            
            % next val
            
            in=input('Center od Cylinder x [mm]: ', 's');

            if isempty(in)
                error('empty value')
            end
            
            ec_obj.geometry.x_centre=str2double(in);
            
            % next val
            
            in=input('Center od Cylinder y [mm]: ', 's');

            if isempty(in)
                error('empty value')
            end
            
            ec_obj.geometry.y_centre=str2double(in);
            
            %next val
            in=input('Accuracy point [mumber]: ', 's');

            if isempty(in)
                error('empty value')
            end
            
            ec_obj.geometry.accuracy=str2double(in);
            
        end
    end
    
end % class    


                

