classdef eElectrical_Field < handle
%Class use to compute and display electrical field
    
    properties
        point_list              % values of point list
        permittivity            % permittivity value for each point_list
        boundary                % boundary values for each point list 'n' means potential must be compute
        neighbours_pidx         % point list values of neighbours for given point list 
        neighbours_iidx         % inverse index of neighbours (iidx)
        potential_maps          % map where computed values will be insert (point list)
        potential_maps_3d_matrix% reshape 3d matrix (electrode_number, :,:,:)
        mesh               % size of mesh (in voxels number e.g. 5x10x8)
    end
    
    methods (Access='public')
    % Constructor:
    %
    % mesh_size;                
    % point_list; 
    % permittivity;
    % boundary;
    % neighbours_pidx;
    % neighbours_iidx;
    % potential_maps;                
          function this = eElectrical_Field(varargin)
          if nargin > 0 ; % no input arguments
          if isa(varargin{1},'eElectrical_Field')
            this = varargin{1}; % copy constructor
            display 'Copy constructor eElectrical_Field'
            return;                     
          else
             switch(nargin)                                  
              
                case 7,                                
                this.mesh=varargin{1};                
                this.point_list=varargin{2}; 
                this.permittivity=varargin{3};
                this.boundary=varargin{4};
                this.neighbours_pidx=varargin{5};
                this.neighbours_iidx=varargin{6};
                this.potential_maps=varargin{7};                  
                
                 otherwise,
                 error('Too less or too much input elements');
             end % switch
          end % if
          end % if
          end % constructor
          
          % input solve method e.g. iterative
          % output potential maps
          potential_maps=solve(varargin)
          
          % plots compute potential
          % mesh X_disp, Y, Z
          % e.g. EF.show_potential('plane',mesh.X_disp,mesh.Y_disp,mesh.Z_disp);
          show_potential(varargin)

                   
    end
    
    methods (Access='private')
        % methods compute potential
        potential_maps=potential_iterative(varargin)
    end %end methods private
    
end

