function  plot_S_map_slice( varargin )
%PLOT_S_MAP_SLICE plot specific slice in specific axes
%   input: el_r
%          el_a
%          axis in 'r' 'c' 'p'
%          point in space (matrix indicies)  12
%   use:   Fp.plot_S_map_slice(1,16,'p',12);

this=varargin{1};
measurements_all=this.measurements_all;
num_of_electrodes=this.num_of_electrodes;

el_a_input=varargin{2};
el_r_input=varargin{3};


axis=varargin{4};

point_in_space=varargin{5};

sm=1;

for el_a=1:num_of_electrodes
    if measurements_all==0
        num = num_of_electrodes;
    else
        num = el_a+num_of_electrodes-1;
    end
    for el_r=el_a+1:num
        if el_r > num_of_electrodes
            el_r = mod(el_r,num_of_electrodes);
        end
        
        if el_r_input==el_r && el_a_input==el_a
            % get selected map
            if strcmp(axis,'p')
                slice(:,:)=this.S_map(sm,:,:,point_in_space);             
            elseif strcmp(axis,'c')
                slice(:,:)=this.S_map(sm,:,point_in_space,:);
            elseif strcmp(axis,'r')
                slice(:,:)=this.S_map(sm,point_in_space,:,:);
            end       
            slice=squeeze(slice);
            imagesc(slice);
        end
        sm = sm + 1;
    end
end

  
end

