classdef eGraphics < handle
    %EGRAPHICS use to set render options     
    
    properties (SetAccess='public')
        axis_v  % e.g. equal
        view_a  % view=[0 75]
        light_a % light_a=[-45 30]
        ligt_type % gouraud
        plot_h % plot handle
        alpha_v % transpaerncy
        alpha_edge % edge transparency
        surface_color % Face Color
        edge_color % Egde color
    end
    
    methods (Access='public')
        function e_gr = eGraphics()
        % constructor is empty default values are set            

                %Default
                    e_gr.axis_v='equal';  % e.g. equal                                        
                    e_gr.view_a=[0,0];  % view=[0 75]                    
                    e_gr.light_a=[0,0]; % light_a=[-45 30]
                    e_gr.ligt_type='gouraud'; % gouraud
                    e_gr.plot_h=gcf; % plot handle
                    e_gr.alpha_v=0.3; % transpaerncy
                    e_gr.alpha_edge=0.3;
                    e_gr.edge_color='none';  % if not use 'none'
                    e_gr.surface_color=[rand rand rand];
        end
        
        function set_render_param(varargin)
            % params.
                % axis_v  % e.g. equal
                % view_a  % view=[0 75]
                % light_a % light_a=[-45 30]
                % ligt_type % gouraud
                % plot_h % plot handle
                % alpha_v % transpaerncy
                % surface_color % Face Color
                % edge_color % Egde color
        
        e_gr=varargin{1};
        params=varargin{2};      
        e_gr.axis_v=params.axis_v;  % e.g. equal
        e_gr.view_a=params.view_a;  % view=[0 75]
        e_gr.light_a=params.light_a; % light_a=[-45 30]
        e_gr.ligt_type=params.ligt_type; % gouraud
        e_gr.plot_h=params.plot_h; % plot handle
        e_gr.alpha_v=params.alpha_v; % transpaerncy
        e_gr.alpha_edge=params.alpha_edge;
        e_gr.edge_color=params.edge_color; %
        e_gr.surface_color=params.surface_color; %
                
        end
    
        function render_gcf(varargin)   
    
            e_gr=varargin{1};

            e_gr.render_figure(gcf)
                   
        end
        
        function render_figure(varargin)   
        % input: handle to surface object
    
         e_gr=varargin{1};        
         fig_handle=varargin{2};
%         axis(e_gr.axis_v);
%         %view(e_gr.view_a(1),e_gr.view_a(2));
%         %lightangle(e_gr.light_a(1),e_gr.light_a(2));
%                 
%         if strcmp(e_gr.ligt_type,'gouraud')
%             
%             camlight; 
%             lighting gouraud
%         elseif strcmp(e_gr.ligt_type,'phong')
%             
%             camlight; 
%             lighting phong
%         else
%             display 'Unrecognize light method'
%         end                
%         
%         set(fig_handle,'Renderer','OpenGL');
         alpha(e_gr.alpha_v); %transparency
           
        end        
            
    
end% methods
    
end

