function S_n = normalize_sensitivity(varargin)
%normalize sensitivity matrix coefficients for 2d   
% input S sensitivity matrix (number of cols must be greater than rows)
%                             each sensitivity map must be write in each
%                             row
%        normalize_mode ('one','avg')
% output Sn normalized sensitivity matrix

this=varargin{1};
S=varargin{2};
normalize_mode=varargin{3};

sz=size(S);

if (numel(sz)==2)
    
    % row>col
    if sz(1)>sz(2)
        error('Transpose this matrix, each sensitivity map must be write in each row');
    else
        
        % normalize mode
        if strcmp(normalize_mode,'one')
            
            % sum over columns
            sc = sum(S);

            S_n = S;

            for j=1:length(sc)
                if sc(j)~=0
                    S_n(:,j)=S(:,j)/sc(j);
                end
            end
        elseif(strcmp(normalize_mode,'avg'))
            % sum over columns
            sc = sum(S);
            
            avg = mean(sc);
            
            S_n = S;
            
            %s(m,n)*avg/t(n);
            
            for j=1:length(sc)
                if sc(j)~=0
                    S_n(:,j)=(S(:,j)*avg)/sc(j);
                end
            end
        end % normalize mode
    end
else
    error('Matrix should have only 2 dimension');
end

end

