classdef eMesh < handle
    % This class contains basic properties and methods for other discretization grid objects.
    
    properties (SetAccess='public')
        mesh_name         % mesh name e.g. cartesian
        size_mm='none'    % (xmin xmax itd) like bounding box
        sampling          % dimension [x,y,z] sampling      
    end
    
    methods (Abstract=true, Access='public')
        set_size(varargin)
        % size of mesh
        % input: bounding_box_xyz                          
        
        [pointlist cube_point_list_and_vertices_of_meshed_object] = set_geometry_object( varargin );
        % set object to mesh (object inherits geometry primitive)                        
        
        [neighbour_point_list_vector xyz_matrix_indicies] = get_neighbours(varargin);
        % point_list_value point list value of discret element
        % returns neighbour_point_list_vector vector of point list values 
        
        [point_list_of_volume]=get_point_list_of_volume(varargin)
        % input: volume size in milimeters (size must be less or equal to current mesh size)
        % e.g. [x_mm_min x_mm_max y_mm_min y_mm_max z_mm_min z_mm_max]
        % return point list of specific volume size
        
        [ neighbours ] = get_all_neighbours( varargin )
        % get all neihgbours from given vector
        % return vector with neighbours
        
    end
    
end

