function [point_list_invp mesh_invp]=getlinear_points_invp(varargin)
% return point_list of given object in when size is set
% input object name
%       set size
% output linear index 
%        size of discrete invp mesh in 3d
this=varargin{1};
name=varargin{2};
num_of_points=varargin{3};
mesh=varargin{4};

fov=this.all_elements.get_elements_by_name({name});

xyz_thick=fov.geometry.get_bounding_box();

minx=xyz_thick(1);
maxx=xyz_thick(2);

miny=xyz_thick(3);
maxy=xyz_thick(4);

minz=xyz_thick(5);
maxz=xyz_thick(6);

xthick=abs(maxx-minx);

ythick=abs(maxy-miny);

zthick=abs(maxz-minz);


xsampling=round(xthick/num_of_points(1));
ysampling=round(ythick/num_of_points(2));
zsampling=round(zthick/num_of_points(3));

if num_of_points(1)==num_of_points(2)
    sampling=round((xsampling+ysampling)/2);    
    xsampling=sampling;
    ysampling=sampling;    
end

% set new sampling

mesh_invp=eCube_Mesh([xsampling ysampling zsampling],'invp_mesh');
% get the same size like original mesh
mesh_invp.size_mm=mesh.size_mm;
point_list_cpy=fov.point_list;

fov.assign_mesh_points(mesh_invp);

point_list_invp=fov.point_list;
% beacause fov point list are change by reference
fov.point_list=point_list_cpy;
size_discrete_xyz=mesh_invp.size_discrete_xyz;

end


