function model_params=create_model_3d(model_params)
max_perm_value_in_FOV=20;
model_params.max_perm_value=max_perm_value_in_FOV;
min_perm_value_in_FOV=1;
model_params.min_perm_value=min_perm_value_in_FOV;



model=eModel('1x16electrode_sensor_and_plexi_rods');

model.add_phantom(model_params.set_phantom);
model.add_sensor(model_params.set_sensor);

%model.get_bounding_box();

mesh=eCube_Mesh([4 4 4],'model_mesh');
assignin('base', 'mesh', mesh);
% get points only in electrode volume

model.assign_mesh_points(mesh);


out=model.calculate_model('electrode',model_params.electrode_potential,0,0,min_perm_value_in_FOV,max_perm_value_in_FOV);

% use for summ 3d sensitivity to 2d 
point_list_of_electrode_volume=mesh.get_point_list_of_volume([ -model_params.model_radius ...
                                                              model_params.model_radius ...
                                                              -model_params.model_radius ...
                                                              model_params.model_radius ...
                                                              0 ...
                                                              180]);

% point_list_of_electrode_volume=mesh.get_point_list_of_volume([ -model_params.model_radius ...
%                                                                model_params.model_radius ...
%                                                                -model_params.model_radius ...
%                                                                model_params.model_radius ...
%                                                                5 ...
%                                                                60]);


point_list_perm_boundary_neighbours_potential_maps=out{1};

point_list=point_list_perm_boundary_neighbours_potential_maps(:,1); 
assignin('base', 'point_list', point_list);
boundary=point_list_perm_boundary_neighbours_potential_maps(:,3);
assignin('base', 'boundary', boundary);
potential_maps=point_list_perm_boundary_neighbours_potential_maps(:,4:min(size(point_list_perm_boundary_neighbours_potential_maps)));     
assignin('base', 'potential_maps', potential_maps);
neighbours_pidx=out{2};
assignin('base', 'neighbours_pidx', neighbours_pidx);
neighbours_iidx=out{3};
assignin('base', 'neighbours_iidx', neighbours_iidx);
permittivity_2d_vector=out{4};
permittivity_3d_matrix=out{5};


% get fov linear points
fov=model.all_elements.get_elements_by_name({'FOV'});
ins1=model.all_elements.get_elements_by_name({'insulator beetween FOV and electrodes'});

model_params.ins1_point_list=ins1.point_list;

model_params.fov_indicies=fov.point_list;

how_compute_capacitance='without_correction';

permittivity_vector{1}=permittivity_2d_vector{1};
permittivity_3d{1}=permittivity_3d_matrix{1};
capacitance_calculation_mode{1}=how_compute_capacitance;

permittivity_vector{2}=permittivity_2d_vector{2};
permittivity_3d{2}=permittivity_3d_matrix{2};
capacitance_calculation_mode{2}=how_compute_capacitance;

permittivity_vector{3}=permittivity_2d_vector{3};
permittivity_3d{3}=permittivity_3d_matrix{3};
capacitance_calculation_mode{3}=how_compute_capacitance;

pha=permittivity_3d{1};
phi(:,:)=pha(:,:,10);
figure
imagesc(phi,[0,10]);
title 'pha';

pha=permittivity_3d{1};
phi(:,:)=pha(:,:,35);
figure
imagesc(phi,[0,10]);
title 'pha';

pha=permittivity_3d{1};
phi2(:,:)=pha(:,25,:);
figure
imagesc(phi2,[0,10]);
title 'pha';

min_p=permittivity_3d{2};
mini(:,:)=min_p(:,:,10);
figure
imagesc(mini,[0,10]);
title 'min';

max_p=permittivity_3d{3};
maxi(:,:)=max_p(:,:,10);
figure
imagesc(maxi,[0,10]);
title 'max';


assignin('base', 'permittivity_vector', permittivity_vector);
assignin('base', 'permittivity_3d', permittivity_3d);
assignin('base', 'capacitance_calculation_mode', capacitance_calculation_mode);

set_sensitivity=eSet('sensitivity_points');
set_sensitivity.add_element(fov);

point_list_fov=set_sensitivity.get_linear_indicies();

% ins1 - insulator between FOV and electrodes
set_sensitivity.add_element(ins1);

point_list_fov_ins=set_sensitivity.get_linear_indicies();

set_sensor=model_params.set_sensor;
elements_between_elctrodes=set_sensor.get_elements_by_name({'Insulator beetween electro'});
set_sensitivity.add_element(elements_between_elctrodes(:));

point_list_FOV_ins1_between_electrodes=set_sensitivity.get_linear_indicies();
%point_list_from_where_get_sensitivity=fov_indicies;


insulator_between_electro_and_screen=set_sensor.get_elements_by_name({'insulator between electro and screen'});
set_sensitivity.add_element(insulator_between_electro_and_screen(:));
point_list_FOV_ins1_between_electrodes_insulator_after_screen=set_sensitivity.get_linear_indicies();


iidx= find(ismember(point_list_of_electrode_volume,point_list_fov));
%iidx= find(ismember(point_list_of_electrode_volume,point_list_fov_ins));
model_params.where_compute_capacitance=point_list_of_electrode_volume(iidx);


iidx= find(ismember(point_list_of_electrode_volume,point_list_fov));
model_params.where_reconstruct=point_list_of_electrode_volume(iidx);

assignin('base', 'model', model);